VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmLoad 
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Used Defined Types Example"
   ClientHeight    =   5160
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   4830
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   Moveable        =   0   'False
   ScaleHeight     =   5160
   ScaleWidth      =   4830
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      BackColor       =   &H00C0C0C0&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   510
      Left            =   150
      ScaleHeight     =   510
      ScaleWidth      =   3405
      TabIndex        =   2
      Top             =   4665
      Width           =   3405
      Begin MSComctlLib.Toolbar Toolbar1 
         Height          =   330
         Left            =   15
         TabIndex        =   3
         Top             =   45
         Width           =   3090
         _ExtentX        =   5450
         _ExtentY        =   582
         ButtonWidth     =   2143
         ButtonHeight    =   582
         Style           =   1
         TextAlignment   =   1
         ImageList       =   "ImageList1"
         _Version        =   393216
         BeginProperty Buttons {66833FE8-8583-11D1-B16A-00C0F0283628} 
            NumButtons      =   2
            BeginProperty Button1 {66833FEA-8583-11D1-B16A-00C0F0283628} 
               Caption         =   "&Load     "
               Key             =   "load"
               ImageIndex      =   1
            EndProperty
            BeginProperty Button2 {66833FEA-8583-11D1-B16A-00C0F0283628} 
               Caption         =   "&Cancel     "
               Key             =   "Cancel"
               ImageIndex      =   3
            EndProperty
         EndProperty
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Load Data"
      Height          =   4470
      Left            =   105
      TabIndex        =   0
      Top             =   90
      Width           =   4575
      Begin MSComctlLib.ListView lstData 
         Height          =   4020
         Left            =   150
         TabIndex        =   1
         Top             =   300
         Width           =   4275
         _ExtentX        =   7541
         _ExtentY        =   7091
         View            =   2
         Sorted          =   -1  'True
         LabelWrap       =   -1  'True
         HideSelection   =   -1  'True
         _Version        =   393217
         SmallIcons      =   "ImageList1"
         ForeColor       =   -2147483640
         BackColor       =   -2147483643
         BorderStyle     =   1
         Appearance      =   1
         NumItems        =   0
      End
      Begin MSComctlLib.ImageList ImageList1 
         Left            =   1380
         Top             =   4200
         _ExtentX        =   1005
         _ExtentY        =   1005
         BackColor       =   -2147483643
         ImageWidth      =   16
         ImageHeight     =   16
         MaskColor       =   12632256
         _Version        =   393216
         BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
            NumListImages   =   3
            BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
               Picture         =   "frmLoad.frx":0000
               Key             =   ""
            EndProperty
            BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
               Picture         =   "frmLoad.frx":015C
               Key             =   ""
            EndProperty
            BeginProperty ListImage3 {2C247F27-8591-11D1-B16A-00C0F0283628} 
               Picture         =   "frmLoad.frx":02B8
               Key             =   ""
            EndProperty
         EndProperty
      End
   End
End
Attribute VB_Name = "frmLoad"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
'//
'// Project: Used Defined Types Example
'// By:      Vladimir S. Pekulas
'// Date:    September 27. 2000
'// Contact: vpekulas@home.com
'// WebHome: http://www.Bohemiatrading.com
'//
'// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$


'// UDT (Used Defined Types) could be used
'// in many ways, this example will show you
'// how to use UDT as a small database.
'// It's quite fast upto around 1000 records
'// anything beyond that will be slower.   :)
'//
'// I have used UDT instead of INT files in
'// the past, simply because it's way easier.

'// UDT is basicly a group of variables
'// that you'll use later on, but declared as a group
'// in this case called "DataInfo"
'// When you're delclaring a string you need to
'// tell VB what's the maximum length.
'// (strTitle can have upto 150 characters)
Private Type DataInfo
    strTitle As String * 150
    strURL As String * 200
    strPass As String * 50
    strLog As String * 50
    strOther As String * 800
End Type

'// File handle for frmLoad (doesn't have to be public)
Public intFileLoad As Integer

'// Keeps track of opened record.
Public lngID_opened As Integer



'// ############################################################
'// Load function will find record by the title which is already
'// displayed and close the form.
Function Load()
  '// Work with UDT
  Dim udtLoadData As DataInfo
  Dim lngNextID As Long
 
 '// Get the full size of the record (add togather 150+200+50+50+800)
 frmMain.lngRecLength = LenB(udtLoadData)
 '// Open file with all data (use Random in our case)
 Open App.Path & "\data.dat" For Random As #intFileLoad Len = frmMain.lngRecLength
  '// Determin last record
  Call frmMain.Number_of_Records
  '// Start at the 'very first record' - 1
  '// First record is 1, however since we are increasing records by 1
  '// we need 0 so, the loop would read the 1st record as well.
  lngID = 0
  '// Repeat following process (until Loop)
  Do
    '// Increase current record number by 1
    lngID = lngID + 1
    '// Check if we still have some record left to compare with title
    If lngID > frmMain.NumRecords Then GoTo Done:
      '// Open lngID record
      Get #intFileLoad, lngID, udtLoadData
        '// Trim selected title and Saved title, compare them.
        '// The 'Trim' function is necessary since the Title from UDT
        '// would include (Title Length - 150) blank spaces.
        If Trim(lstData.SelectedItem.Text) = Trim(udtLoadData.strTitle) Then
           '// If it's the same then trim each and display it to main form.
           frmMain.txtTitle.Text = Trim(udtLoadData.strTitle)
           frmMain.txtURL.Text = Trim(udtLoadData.strURL)
           frmMain.txtPass.Text = Trim(udtLoadData.strPass)
           frmMain.txtLog.Text = Trim(udtLoadData.strLog)
           frmMain.txtOther.Text = Trim(udtLoadData.strOther)
           '// Let's close opened file !
           Close #intFileLoad
           '// Remember what record is opened
           lngID_opened = lngID
           '// and now we can unload the whole form
           Unload Me
           '// We need to exit this function !
           Exit Function
        End If
  Loop
 '// Close current file
 Close #intFileLoad
 
'// If we were unable to find what user selected then give him/her the message.
Exit Function
Done:
 MsgBox "Unable to find selected data.", vbCritical, "Error loading data"
 '// Let's not forget to close opened file !
 Close #intFileLoad
End Function



'// #####################################################################
'// LoadTitles function will open the data file and read all titles there
'// are and add them to the lstData with an icon #2.
'// The code is pretty much the same as the one above.

Function LoadTitles()
  Dim udtLoadData As DataInfo
  Dim lngNextID As Long
 
 '// Get the full size of the record (add togather 150+200+50+50+800)
 frmMain.lngRecLength = LenB(udtLoadData)
 '// Open file with all data
 Open App.Path & "\data.dat" For Random As #intFileLoad Len = frmMain.lngRecLength
  '// Determin last record
  frmMain.Number_of_Records
  '// Assign ID to the begining (1st record - 1)
  lngID = 0
  '// repeat process until loop
  Do
   '// increase record number
   lngID = lngID + 1
     '// check if we still have any rocord left
     If lngID > frmMain.NumRecords Then GoTo Done:
      '// Open record
      Get #intFileLoad, lngID, udtLoadData
        '// Add trimed title to lstData
        CurrentTitle = Trim(udtLoadData.strTitle)
        lstData.ListItems.Add , , CurrentTitle, , 2
  '// repeate
  Loop
'// Close file
Close #intFileLoad

'// This "If lngID > frmMain.NumRecords Then GoTo Done:" will kick us here
Exit Function
Done:
 Close #intFileLoad
End Function


'// Initiate free file handle and load saved records (titles)
Private Sub Form_Activate()
  intFileLoad = FreeFile
  LoadTitles
End Sub

'// Open record if user double-clicked on title
Private Sub lstData_DblClick()
  Load
End Sub

'// Menu interface
Private Sub Toolbar1_ButtonClick(ByVal Button As MSComctlLib.Button)
    Select Case Button.Key
           Case "Cancel"
                Unload Me
           Case "load"
                Load
    End Select
End Sub
